//:: case MPAOApplication

//:: case MPAODefined
//:: tool silicon
//:: options --check-defined

//:: case MPAOAxioms
//:: tool silicon
//:: options --check-axioms

/*
  vct --silver=silicon --check-axioms Future.java
  vct --silver=silicon --check-defined Future.java
*/
// begin(put) begin(get) begin(all)
public class Future {
/*@
    requires valid(source, dest, msg, tag);
    ensures true;
    process isend(int source, int dest, Object msg, int tag);

    ensures true;
    process waitsend(int r);

    ensures true;
    process irecv(int source, int dest, int tag, int r);

    ensures true;
    process waitrecv(int source, int dest, Object msg, int tag, int r);
@*/

/*@
    ensures true;
    process send(int source, int dest, Object msg, int tag) =
        \sum(int r; isemd(source, dest, msg, tag, r) *
             waitsend(r));

    ensures true;
    process recv(int source, int act_source, int dest, Object msg, int tag,
                 int act_tag) =
        \sum(int r; irecv(source, dest, tag, r) *
             waitrecv(act_source, dest, msg, act_tag, r));
@*/

/* @
    process objectLoopMath(int source) =
        \sum(Call call, Result result;
            recv(MPI.ANY_SOURCE, source, call, objectId) *
            send(source, call.source, result, call.callId)
        ) * objectLoop(source);
@ */
}
//end(all)
