import java.io.Serializable;

public class MergeSortRemote implements RemoteObject {
    private final int workerId;
    private final int objectId;

    public MergeSortRemote(int workerId, int objectId) {
        this.workerId = workerId;
        this.objectId = objectId;
    }

    public RemoteFuture<int[]> sort(int[] list, int iteration) {
        return new RemoteFuture<int[]>(
                MPAO.callMethod(workerId, objectId, "sort", new Serializable[] { list, iteration }));
    }
}
